import java.io.File;
import java.util.Iterator;
import java.util.List;
import dao.*;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import sun.security.util.Debug;

public class PlanilhaDB {

    private static Connection conexao;
    private static Statement stmt ;  
	private Dao persist;
	private ResultSet rs1;	
	private static final String repositorio="\\planilhas";
	private int numRemesa=1020;
	private int numLote=2;	
	
	public static void main(String[] args) {
		PlanilhaDB pdb=new PlanilhaDB();
		pdb.run();
	}
	
	private void run(){
		String query;
		
		abreBancoDeDados();
		query=" select sq_setor,nm_setor from tb_setor where " +
				"tp_setor = 'VT' and in_setor = 'I' " +
				" order by sq_setor" ;
				//"and sq_setor between 317 and 400" ;
		//query=" select cd_numeracao_unica,nm_setor from tb_setor where tp_setor = 'VT' and in_setor = 'I'" ;
				
		ResultSet setores = leBancoDeDados(query);
		try {
			int sqSetor;
			String nmSetor;
			
			while(setores.next()) {				
				sqSetor=setores.getInt(1);
				nmSetor=setores.getString(2);
				executaParaCadaSetor(sqSetor,numRemesa,numLote,nmSetor);	
				//System.out.println(cd_numeracao_unica);
			}	
		}catch(Exception e){
			e.printStackTrace();
		}
		
		try{
			rs1.close();
			
		}catch(Exception e){
			e.printStackTrace();
		}		
		System.out.println("\nFim do programa!");		
	}
	
	private void executaParaCadaSetor(int sq_setor, int numRemessa,int numLote,String nm_setor){
		String query;


		query=	"select  nm_setor," +
				"ei.des_item," +
				"i.num_item," +
				"sf_aux_fmt_nrprocesso(pr.nr_processo_atual) processo," +
				"cp.nom_classe," +
				"nm_juiz,         " +
				"i.dta_evento_inicial,i.dta_evento_final," +
				"i.dta_evento_final-i.dta_evento_inicial prazo," +
				"sq_processo " +
				"from egt_info_processo i " + 
				"inner join egt_estrutura_item ei on ei.num_item=i.num_item " +
				"inner join tb_processo pr on pr.sq_processo=num_interno_processo " +
				"inner join tb_setor s on s.sq_setor=i.num_orgao_estatistica " +
				"inner join egt_classe_processual cp on cp.num_classe=i.num_classe " +
				"left join tr_juiz_pessoa jp on jp.num_pessoa=i.num_juiz " +
				"left join tb_juiz j on j.sq_juiz=jp.sq_juiz " +
				"where i.num_remessa =" + numRemessa + " and i.num_lote=" + numLote  +
				"      and num_orgao_estatistica=" + sq_setor +
				" order by 3,4";
		
	/*	query="select num_interno_processo from egt_info_processo" +
					" where num_remessa=1013" +
					"	and num_lote=74" +
					" and num_orgao_estatistica=" + sq_setor;*/
		
		rs1=leBancoDeDados(query);
		
	
		
		PlanilhaManager pm= new PlanilhaManager(rs1, new File("Planilhas\\"+nm_setor + ".xls"));
		pm.executar();
		
		try {
			rs1.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	private void abreBancoDeDados(){
		persist=new DaoOracle();
		try{
			persist.open();	
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private ResultSet leBancoDeDados(String query){
		try{
			ResultSet rs=persist.executarQuery(query);
			return rs;
		}catch(Exception e){
			e.printStackTrace();
			return null;		
		}
	}
		
}
