import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import  java.sql.ResultSet;
import org.apache.poi.hssf.usermodel.*;
import java.io.*;
import java.sql.ResultSetMetaData;;

public class PlanilhaManager {

	private ResultSet rs1;
	private File nomeArquivo;
	private HSSFWorkbook workBook;
	private HSSFSheet sheet;
	private String[] nomeColunas;
	
	public PlanilhaManager(ResultSet rs1,File nomeArquivo){
		this.rs1=rs1;	
		this.nomeArquivo=nomeArquivo;
	}

	public void executar(){
		criaWorkbook();
		//workBook.removeSheetAt(0);
		criarAba("Aba 1",rs1);
		
		write();
	}
	
	private void criarAba(String titulo, ResultSet rs){
		criaSheet(titulo);
		criaCabecalho(rs);		
		int contLinha=1;
		try{
			while(rs.next()) {
				HSSFRow row = sheet.createRow(contLinha++);
				for (int i=0;i<nomeColunas.length;i++){
					HSSFCell cell=row.createCell((short)i);
					cell.setCellValue(rs.getString(nomeColunas[i]));	
				};
			}
		}catch(Exception e){
			e.printStackTrace();
		}	
}

	private void criaWorkbook(){
		try{
			if (nomeArquivo.exists()){
				System.out.println("Lendo arquivo "+nomeArquivo);
				workBook = new HSSFWorkbook(new FileInputStream(nomeArquivo));
			}else{
				System.out.println("Criando arquivo "+nomeArquivo);
				workBook = new HSSFWorkbook();
			}
		}catch(Exception e){
			System.out.println("Erro na criao do workbook: " + e.getMessage());
			System.exit(0);
		}
	}
	
	private void criaSheet(String name){
		try{
			sheet=workBook.getSheet(name);
			
			if (sheet==null){
				System.out.println("Criando sheet "+name);
				sheet = workBook.createSheet(name);
			}else{
				System.out.println("excluindo sheet "+name);
				workBook.removeSheetAt(workBook.getSheetIndex(name));
				sheet = workBook.createSheet(name);
			}
		}catch(Exception e){
			System.out.println("Erro na criao do sheet " +e.getMessage());
			System.exit(0);
		}
	}
	
	private void criaCabecalho(ResultSet rs){
		try{
			ResultSetMetaData meta=rs.getMetaData();
			int numColunas=meta.getColumnCount(); 
			nomeColunas=new String[numColunas];
			
			HSSFRow row = sheet.createRow(0);
			for(int i=1;i<numColunas+1;i++){
				nomeColunas[i-1]=meta.getColumnLabel(i);
				HSSFCell cell=row.createCell((short)i-1);
				cell.setCellValue(meta.getColumnLabel(i));
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void write(){
		
		try{
			workBook.write(new FileOutputStream(nomeArquivo));
		}catch(Exception e){
			System.out.println("Erro na criao do workbook: " + 
					e.getMessage());
			System.exit(0);
		}
	}
}
