import java.io.File;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

import dao.Dao;
import dao.DaoOracle;

public class RelatorioInventario {
	private static Connection conexao;
    private static Statement stmt ;  
	private Dao persist;
	private ResultSet rsSetores;
	private ResultSet rs;
	private static final String REPOSITORIO="C:\\Documents and Settings\\roterdam.junior\\Meus documentos\\SAPWEB\\Relatorios\\Inventario\\";
	private static final String QUERY_PARTE_1=
		"	select distinct nr_processo_atual,	"	+
		"	                sg_tipo_processo,	"	+
		"	                nr_processo,	"	+
		"	                max(dt_andamento) data_inventario,	"	+
		"	                fase,	"	+
		"	                sg_setor SETOR_JULGADOR,	"	+
		"	                FL_INVENTARIO as INVENTARIADO,	"	+
		"	                in_situacao	"	+
		"	  from (select distinct a.nr_processo_atual,	"	+
		"	                        sg_tipo_processo,	"	+
		"	                        substr(a.nr_processo_atual, 1, 5) || '-' ||	"	+
		"	                        substr(a.nr_processo_atual, 6, 4) || '-' ||	"	+
		"	                        substr(a.nr_processo_atual, 10, 3) || '-01-' ||	"	+
		"	                        substr(a.nr_processo_atual, 15, 2) || '-' ||	"	+
		"	                        substr(a.nr_processo_atual, 17) nr_processo,	"	+
		"	                        a.dt_andamento,	"	+
		"	                        case	"	+
		"	                          when a.in_fase = 'C' then	"	+
		"	                           'Conhecimento'	"	+
		"	                          when a.in_fase = 'L' then	"	+
		"	                           'Liquidao'	"	+
		"	                          when a.in_fase = 'E' then	"	+
		"	                           'Execuo'	"	+
		"	                          when a.in_fase = 'P' then	"	+
		"	                           'Previdenciaria'	"	+
		"	                          when a.in_fase = 'J' then	"	+
		"	                           'Jurisdio Voluntria'	"	+
		"	                          when a.in_fase = 'R' then	"	+
		"	                           'Recursal'	"	+
		"	                          when a.in_fase = 'U' then	"	+
		"	                           'Cumprimento'	"	+
		"	                        end FASE,	"	+
		"	                        a.sg_setor,	"	+
		"	                        FL_INVENTARIO,	"	+
		"	                        p.in_situacao	"	+
		"	          from tmp_consulta_inventario A	"	+
		"	         inner join tb_processo P on p.sq_processo = A.sq_processo	"	+
		"	         inner join tb_tipo_processo tp on tp.sq_tipo_processo =	"	+
		"	                                           p.sq_tipo_processo	"	+
		"	         where p.sq_setor not in (172, 1, 5703, 271)	"	;

	
	private static final String QUERY_PARTE_2=
		"	           and sg_tipo_processo <> 'AI'	"	+
		"	           and p.in_situacao not in ('FI', 'CA')	"	+
		"	           and not exists (select sq_processo	"	+
		"	                  from tb_processo pr	"	+
		"	                 where pr.sq_processo = a.sq_processo	"	+
		"	                   and pr.sq_setor_julgador <> pr.sq_setor	"	+
		"	                   and sq_tipo_processo in (100, 27)) "	+
		" 			   and not exists (select pec.sq_processo" +
        "         						from tb_peca pec " +
        "        						inner join tb_peca_apenso pa on pa.sq_peca=pec.sq_peca" +
		"								where pec.sq_processo = a.sq_processo" +
        "         						and sq_tipo_processo in (8, 15))" + 
		"	        )	"	+
		"	 group by nr_processo,	"	+
		"	          fase,	"	+
		"	          sg_setor,	"	+
		"	          nr_processo_atual,	"	+
		"	          FL_INVENTARIO,	"	+
		"	          in_situacao,	"	+
		"	          sg_tipo_processo	"	;

	
	public static void main(String[] args) {
		RelatorioInventario ri=new RelatorioInventario();
		ri.run();
	}
	
	private void run(){
		abreBancoDeDados();
		leSetores();
		
		try{
			while(rsSetores.next()) {
				String query=QUERY_PARTE_1 + 
							" and p.sq_setor_julgador =" + rsSetores.getString("sq_setor") +
							 QUERY_PARTE_2;
				
				
				rs=persist.executarQuery(query);
				//PlanilhaManager pm= new PlanilhaManager(rs, new File(REPOSITORIO+ rsSetores.getString("nm_setor")+".xls"));
				//pm.executar();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
			
		try{
			rsSetores.close();
		}catch(Exception e){
			e.printStackTrace();
		}		
		System.out.println("\nFim do programa!");		
	}
	
	private void abreBancoDeDados(){
		persist=new DaoOracle();
		try{
			persist.open();	
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void leSetores(){
		try{
			String query="select sq_setor,nm_setor from tb_setor  ";
			query+="where nvl(cd_numeracao_unica,0)>0 and nvl(cd_numeracao_unica,0)<999 ";
			query+="and in_setor='I'";
			rsSetores=persist.executarQuery(query);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	
}
