package dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class Dao {

	private static String BD_CLASSE ;
	private static String BD_URL;
    private static String BD_USUARIO ;
    private static String BD_SENHA ;
    private static Connection conexao;

	public void open() throws SQLException   {          
		System.out.println("Conectando...");
		try {
            Class.forName(BD_CLASSE);
            conexao = DriverManager.getConnection(BD_URL,BD_USUARIO,BD_SENHA);
        }catch (ClassNotFoundException e)
        {e.printStackTrace();}
        System.out.println("Conectado!");

    }
	
    public void executar(String query){
    	Statement s=null;

    	try{
    		s = conexao.createStatement();
    		s.execute(query);
    	}catch (SQLException e){
    		System.out.println("Erro na execuo!"+e.getMessage());
    		//e.printStackTrace();
        }
    	finally{
    		//close(r);
    		close(s);
    		//close(c);
        }
    }
    
    public ResultSet executarQuery(String query){
    	Statement s=null;
    	ResultSet r=null;

    	try{
    		s = conexao.createStatement();
    		r=s.executeQuery(query);
    	return r;
    	}catch (SQLException e){
    		System.out.println("Erro na execuo!"+e.getMessage());
    		//e.printStackTrace();
    		return null;
        }
    	/*finally{
    		close(r);
    		close(s);
    		close(c);
        }*/
    }
    
    protected static void close(Connection c){
        if( c != null ){
            try{
                c.close();
            }catch (SQLException e){
            }
        }
    }
    
    protected static void close(ResultSet c){
        if( c != null ){
            try{
                c.close();
            } catch (SQLException e)
            {           	
            }
        }
    }
    
    protected static void close(Statement c)    {
        if( c != null ){
            try{
                c.close();
            } 
            catch (SQLException e)
            {
            }
        }
    }
    

    
    protected void setClasse(String classe){
		BD_CLASSE=classe;
	}

    protected void setUrl(String url){
		BD_URL=url;
	}
	
    protected void setUsuario(String usuario){
		BD_USUARIO=usuario;
	}
	
    protected void setSenha(String senha){
		BD_SENHA=senha;
	}

}
