CREATE OR REPLACE FUNCTION "SF_VIGENCIA_SETOR" (p_sq_setor number,
                                             p_dt_inicio_apuracao date,
                                             p_dt_fim_apuracao date)
return varchar2 is

/*  
  Autor:    Roterdam Jr
  Objetivo: Retorna 'S' se o setor tem lote a ser gerado no perdodo passado como parmetro               
*/
/* TESTE
select sf_vigencia_setor(450,'01/10/2011','31/10/2011') from dual; --S
select sf_vigencia_setor(450,'01/10/2012','31/10/2011') from dual; --S
select sf_vigencia_setor(339,'01/01/2011','31/01/2011') from dual; --S
select sf_vigencia_setor(339,'01/02/2011','28/02/2011') from dual; --N
select sf_vigencia_setor(9324,'01/01/2011','31/01/2011') from dual; --S
select sf_vigencia_setor(9324,'01/02/2011','28/02/2011') from dual; --S
select sf_vigencia_setor(10244,'01/10/2011','31/10/2011') from dual; --N
select sf_vigencia_setor(10244,'01/11/2011','30/11/2011') from dual; --N
*/
  Result          varchar2(1);
  v_dt_inicio_vig date;
  v_dt_fim_vig    date;

begin
  
  select dt_inicio,dt_fim
  into v_dt_inicio_vig, v_dt_fim_vig
  from tb_vigencia_setor
  where sq_setor=p_sq_setor;
  
  if v_dt_inicio_vig > p_dt_fim_apuracao     
     or v_dt_inicio_vig is null then
     return 'N';
  else 
     if v_dt_fim_vig is null then 
         return 'S';
     else    
         if v_dt_fim_vig > p_dt_inicio_apuracao then
            return 'S';
          else 
            return 'N';
          end if;  
     end if;       
  end if;      

exception when others then 
  return null;
       
end sf_vigencia_setor;

 