-------------------------------------------------------
-- Export file for user EG                           --
-- Created by roterdam.junior on 28/9/2012, 16:24:00 --
-------------------------------------------------------


CREATE OR REPLACE PROCEDURE "SP_VALIDACAO_CONJ_DETALHADA" (p_sq_setor number,
                                                   p_num_regra number,
                                                   p_num_remessa number,
                                                   p_num_lote number) is



cursor cAmenosB is
  select *
  from vl_processos_conj_a i1
  where not exists
        (select 1
         from vl_processos_conj_b i2
         where i1.num_interno_processo=i2.num_interno_processo);

cursor cBmenosA is
  select *
  from vl_processos_conj_b i1
  where not exists
        (select 1
         from vl_processos_conj_a i2
         where i1.num_interno_processo=i2.num_interno_processo);

v_operador varchar2(20);
v_conj_a varchar(60);
v_conj_b varchar(60);

begin

    select r.operador
    into v_operador
    from vl_regras_nao_temp r
    where r.num_regra = p_num_regra;

    v_conj_a := sf_escreve_conj_regra(p_num_regra, 'A');
    v_conj_b := sf_escreve_conj_regra(p_num_regra, 'B');

    for c1 in cAmenosB loop
        insert into vl_log_detalhado (sq_setor,
                                      num_regra,
                                      num_interno_processo,
                                      desc_erro,
                                      num_remessa,
                                      num_lote)
        values (p_sq_setor,
                p_num_regra,
                c1.num_interno_processo,
                'Pertence ao Conj' || v_conj_a || 
                ' mas no pertence ao Conj' || v_conj_b,
                p_num_remessa,
                p_num_lote);
    end loop;

    if v_operador not in ('SC_CONTIDO', 'SC_CONTIDO_SC') then

        for c2 in cBmenosA loop
            insert into vl_log_detalhado (sq_setor,
                                          num_regra,
                                          num_interno_processo,
                                          desc_erro,
                                          num_remessa,
                                          num_lote)
            values (p_sq_setor,
                p_num_regra,
                c2.num_interno_processo,
                'Pertence ao Conj' || v_conj_b || 
                ' mas no pertence ao Conj' || v_conj_a,
                p_num_remessa,
                p_num_lote);
        end loop;

    end if;

    commit;
end;
