-------------------------------------------------------
-- Export file for user EG                           --
-- Created by roterdam.junior on 28/9/2012, 16:29:09 --
-------------------------------------------------------
CREATE OR REPLACE PROCEDURE "SP_VALIDACAO" (p_num_remessa number,
                                         p_num_lote number, 
                                         p_num_remessa_ant number, 
                                         p_num_lote_ant number) is

cursor cSetor is
     select sq_setor
     from tb_setor
     where tp_setor = 'VT'
       and in_situacao = 'A'
       and in_setor = 'I';
      -- and sq_setor in (318, 456); --TESTE

cursor cRegras_nao_temp(p_tp_regra vl_regras_nao_temp.tp_regra%type) is
       select * 
       from vl_regras_nao_temp 
       where tp_regra=(p_tp_regra)      
      -- and num_regRa in(110,107,106,105,115) ----> TESTE       
       order by num_regra;

cursor cRegras_temp is
       select *
       from vl_regras_temp
       order by num_regra;
--        where num_regra = 1;

cursor cItens_nao_temp_a(p_num_regra number) is
       select *
       from vl_itens_nao_temp_a 
       where num_regra=p_num_regra
       order by num_item;

cursor cItens_nao_temp_b(p_num_regra number) is
       select *
       from vl_itens_nao_temp_b
       where num_regra=p_num_regra
       order by num_item;

cursor cItens_temp(p_num_regra number,p_tp_item vl_itens_temp.tp_item%type) is
       select *
       from vl_itens_temp
       where num_regra=p_num_regra
             and tp_item=p_tp_item
       order by num_item;

v_msg varchar2(200);


--------------------------------------------------------------------------      
procedure popula_log(p_num_regra number,
                     p_desc_regra vl_regras_temp.desc_regra%type,
                     p_sq_setor number,                      
                     p_msg vl_log.msg%type, 
                     p_in_validacao vl_log.in_validacao%type,
                     p_tp_regra varchar2) is

begin
  insert into vl_log values (p_sq_setor,
                             p_num_regra,
                             p_desc_regra,                               
                             p_msg,
                             p_in_validacao,
                             p_tp_regra,
                             p_num_remessa,
                             p_num_lote);
  commit;                                                               
end;

--------------------------------------------------------------------------      
procedure aborta is
begin
    popula_log (null,null, null, 'Erro na execuo','Erro', null);

end;
-------------------------------------------------------------------------- 
function ConjuntoValido(operador varchar2) return boolean is
  
  result   boolean;
  v_cont_a number;
  v_cont_b number;
  
begin
  
  result := false;
  
  if operador in ('SC_IGUAL_RITO_SUM', 'SC_IGUAL_RITO_COM', 'SC_IGUAL', 'SC_IGUAL_SC') then
   
    select count(*)
    into v_cont_a
    from vl_processos_conj_a a
    where not exists
       (select * from vl_processos_conj_b b 
        where a.num_interno_processo = b.num_interno_processo);
    
    select count(*)
    into v_cont_b
    from vl_processos_conj_b b
    where not exists
       (select * from vl_processos_conj_a a 
        where a.num_interno_processo = b.num_interno_processo);
    
    if v_cont_a + v_cont_b = 0 then
      result := true;
    end if;
    
  elsif operador in ('SC_CONTIDO', 'SC_CONTIDO_SC') then

    select count(*)
    into v_cont_a
    from vl_processos_conj_a a
    where not exists
       (select * from vl_processos_conj_b b 
        where a.num_interno_processo = b.num_interno_processo);
    
    if v_cont_a = 0 then
      result := true;
    end if;
    
  end if;
  
  return result;
end;

----------------------------------------------------------------------------
--prepara os conjuntos A e B da regra
procedure prepara_conjuntos(p_num_regra number, p_sq_setor number, p_classes boolean) is

begin

     delete from vl_processos_conj_a;
     delete from vl_processos_conj_b;
     delete from vl_temp_classes;

     commit;

     -- carrega vl_processos_conj_a com processos que atendam determinados itens
     for i in cItens_nao_temp_a(p_num_regra) loop
        insert into vl_processos_conj_a
          select  /*+index (egt_info_processo egt_info_processo_extra) */ num_interno_processo, num_classe, num_item
          from egt_info_processo ei
          where num_remessa = p_num_remessa
             and num_lote = p_num_lote
             and num_orgao_estatistica = p_sq_setor
             and num_item = i.num_item;
     end loop;   

     -- carrega vl_processos_conj_b com processos que atendam determinados itens
     for i in cItens_nao_temp_b(p_num_regra) loop
        insert into vl_processos_conj_b
          select  /*+index (egt_info_processo egt_info_processo_extra) */ num_interno_processo, num_classe, num_item
          from egt_info_processo ei
          where num_remessa = p_num_remessa
             and num_lote = p_num_lote
             and num_orgao_estatistica = p_sq_setor
             and num_item = i.num_item;
     end loop;   
 
     --se for para considerar as classes
     if p_classes then 
         --carrega a vl_temp_classes com as classes permitidas do conjunto A da regra
         for a in cItens_nao_temp_a(p_num_regra) loop
             insert into vl_temp_classes
             (select fc.num_classe
              from vl_item i inner join vl_familia_classe fc on i.sq_familia_base = fc.sq_familia
              where i.num_item = a.num_item)
              minus
             (select fc.num_classe
              from vl_item i inner join vl_familia_classe fc on i.sq_familia_exclui = fc.sq_familia
              where i.num_item = a.num_item);
         end loop; 

         --tira do conjunto B os processos cujas classes no so do conjunto A
         delete from vl_processos_conj_b b 
         where b.num_classe not in (select * from vl_temp_classes);
     end if;

     commit;
end;

------------------- VALIDAO NO TEMPORAL DE QUANTIDADE ----------------------
function retornaQuant(p_num_regra number, p_sq_setor number, p_conj char) return number is

v_qt number;

begin
      v_qt := 0;
      if p_conj = 'A' then
          for i in cItens_nao_temp_a(p_num_regra) loop
              v_qt := v_qt + sf_quant_procs_item(p_num_remessa, p_num_lote,p_sq_setor,i.num_item);
              
          end loop;    
      else
          for i in cItens_nao_temp_b(p_num_regra) loop
              v_qt := v_qt + sf_quant_procs_item(p_num_remessa, p_num_lote,p_sq_setor,i.num_item);
          end loop;  
      end if;
      return v_qt;
end;

----------------------------------------------------------------------------------


procedure validacao_nao_temporal_quant(p_sq_setor number) is
   v_qt_a number;
   v_qt_b number;
   v_vr_a number;
   v_conj_a varchar2(60);
   v_conj_b varchar2(60);

begin

  for r in cRegras_nao_temp('Q') loop
      prepara_conjuntos(r.num_regra, p_sq_setor, false);

      -- calcula quantidade do 1o operador em v_qt_a
      v_qt_a:=retornaQuant(r.num_regra, p_sq_setor, 'A');

      -- calcula quantidade do 1o operador em v_qt_b
      v_qt_b:=retornaQuant(r.num_regra, p_sq_setor, 'B');

    --verifica validade
    v_msg:= 'Quant' || sf_escreve_conj_regra(r.num_regra, 'A') || ': ' ||    v_qt_a || 
            '  Quant' || sf_escreve_conj_regra(r.num_regra, 'B') || ': ' ||    v_qt_b; 

    if r.operador = 'QT_MAIOR_IGUAL' then
        if v_qt_a >= v_qt_b then
           popula_log (r.num_regra, r.desc_regra, p_sq_setor, v_msg,'OK', 'NTEMP');
        else
           popula_log (r.num_regra,r.desc_regra, p_sq_setor, v_msg,'Erro','NTEMP');
           sp_validacao_quant_detalhada(p_sq_setor, r.num_regra, p_num_remessa, p_num_lote, 'Q', 'QT_MAIOR_IGUAL');
        end if;    
    elsif  r.operador ='QT_MENOR_IGUAL' then
        if v_qt_a <= v_qt_b then
           popula_log (r.num_regra,r.desc_regra, p_sq_setor, v_msg,'OK','NTEMP');
        else
           popula_log (r.num_regra,r.desc_regra, p_sq_setor, v_msg,'Erro','NTEMP');
           sp_validacao_quant_detalhada(p_sq_setor, r.num_regra, p_num_remessa, p_num_lote, 'Q', 'QT_MENOR_IGUAL');
        end if;
    elsif  r.operador = 'QT_IGUAL' then
        if v_qt_a = v_qt_b then
           popula_log (r.num_regra,r.desc_regra, p_sq_setor, v_msg,'OK', 'NTEMP');
        else
           popula_log (r.num_regra,r.desc_regra, p_sq_setor, v_msg,'Erro', 'NTEMP');
           sp_validacao_quant_detalhada(p_sq_setor, r.num_regra, p_num_remessa, p_num_lote, 'Q', 'QT_IGUAL');
        end if;
    else
        aborta;
    end if;
        
  end loop;

  for r in cRegras_nao_temp('QV') loop
      if r.operador in ('QV_1', 'QV_1_2') then
          prepara_conjuntos(r.num_regra, p_sq_setor, true);
      elsif r.operador in ('QV_1_SC', 'QV_1_2_SC') then --no considera classes
          prepara_conjuntos(r.num_regra, p_sq_setor, false);
      end if;

      select count(*)
      into v_qt_a
      from vl_processos_conj_a;

      select count(*)
      into v_qt_b
      from vl_processos_conj_b;

       -- calcula o valor do item do conjunto a em v_vr_a
      begin
          select ii.num_valor_item
          into v_vr_a
          from egt_info_item ii
          where num_remessa = p_num_remessa
             and num_lote = p_num_lote
             and num_orgao_estatistica = p_sq_setor
             and num_item = (select a.num_item
                              from vl_itens_nao_temp_a a
                              where num_regra=r.num_regra
                                    and rownum=1);--considerando que o conjunto A sempre ter apenas 1 item
      exception when others then
          v_vr_a := 0;
      end;

      v_conj_a := sf_escreve_conj_regra(r.num_regra, 'A');
      v_conj_b := sf_escreve_conj_regra(r.num_regra, 'B');

      --todas as regras do tipo 'QV' (Quantidade e Valor) possuem a parte 1
      if v_qt_b = 0 then
          if v_qt_a = 0 and v_vr_a is null then
              popula_log (r.num_regra, 
                          r.desc_regra, 
                          p_sq_setor, 
                          'Quant' || v_conj_b || ' = ' || v_qt_b ||
                          '  Quant' || v_conj_a || ' = ' || v_qt_a ||
                          '  Valor' || v_conj_a || ' = ' || v_vr_a,'OK',
                          'NTEMP');
          else
              popula_log (r.num_regra, 
                          r.desc_regra, 
                          p_sq_setor, 
                          'Quant' || v_conj_b || ' = ' || v_qt_b ||
                          '  Quant' || v_conj_a || ' = ' || v_qt_a ||
                          '  Valor' || v_conj_a || ' = ' || v_vr_a,'Erro',
                          'NTEMP');
              sp_validacao_quant_detalhada(p_sq_setor, r.num_regra, p_num_remessa, p_num_lote, 'QV', null);
          end if;
      end if;

      --para as que possuem tambm a parte 2
      if r.operador = 'QV_1_2' then
          if v_qt_b > 0 then
              if v_qt_a > 0 and v_vr_a >= 0 then
                  popula_log (r.num_regra, 
                          r.desc_regra, 
                          p_sq_setor, 
                          'Quant' || v_conj_b || ' = ' || v_qt_b ||
                          '  Quant' || v_conj_a || ' = ' || v_qt_a ||
                          '  Valor' || v_conj_a || ' = ' || v_vr_a,'OK',
                          'NTEMP');
              else
                  popula_log (r.num_regra, 
                              r.desc_regra, 
                              p_sq_setor, 
                              'Quant' || v_conj_b || ' = ' || v_qt_b ||
                              '  Quant' || v_conj_a || ' = ' || v_qt_a ||
                              '  Valor' || v_conj_a || ' = ' || v_vr_a,'Erro',
                              'NTEMP');
                  sp_validacao_quant_detalhada(p_sq_setor, r.num_regra, p_num_remessa, p_num_lote, 'QV', null);
              end if;
          end if;
      end if;

  end loop;

end;



------------------- VALIDAO NO TEMPORAL DE CONJUNTO ----------------------
procedure validacao_nao_temporal_conj(p_sq_setor number) is
  v_qt_conj_a number;
  v_qt_conj_b number;

begin

   
  for r in cRegras_nao_temp('C') loop
     if r.operador in ('SC_CONTIDO_SC', 'SC_IGUAL_SC') then --no considera classes
        prepara_conjuntos(r.num_regra, p_sq_setor, false);
     elsif r.operador in ('SC_CONTIDO', 'SC_IGUAL', 'SC_IGUAL_RITO_SUM', 'SC_IGUAL_RITO_COM') then
        prepara_conjuntos(r.num_regra, p_sq_setor, true);
     end if;

     -- compara conjuntos
    
     if ConjuntoValido(r.operador) then
        popula_log (r.num_regra,r.desc_regra, p_sq_setor, v_msg,'OK', 'NTEMP');
     else
        select count(*) 
        into v_qt_conj_a
        from vl_processos_conj_a;

        select count(*) 
        into v_qt_conj_b
        from vl_processos_conj_b;        
        
        popula_log (r.num_regra,r.desc_regra, p_sq_setor, null,'Erro', 'NTEMP');     
        
        -- popula log de detalhamento  
        sp_validacao_conj_detalhada(p_sq_setor,r.num_regra,p_num_remessa, p_num_lote);
     end if;    

  end loop;

end;

------------------- VALIDAO  TEMPORAL ----------------------
procedure validacao_temporal(p_sq_setor number) is
   v_qt_pendente_ant number;
   v_qt_entrada      number;
   v_qt_saida        number;
   v_qt_pendente     number;

begin

  for r in cRegras_temp loop

      v_qt_pendente_ant :=0;
      v_qt_entrada :=0; 
      v_qt_saida :=0; 
      v_qt_pendente:=0;

      --calcula pendente anterior
      for i in cItens_temp(r.num_regra, 'P') loop
          v_qt_pendente_ant := v_qt_pendente_ant + sf_quant_procs_item(p_num_remessa_ant, p_num_lote_ant,p_sq_setor,i.num_item);
      end loop;

      --calcula entrada
      for i in cItens_temp(r.num_regra, 'E') loop
          v_qt_entrada := v_qt_entrada + sf_quant_procs_item(p_num_remessa, p_num_lote,p_sq_setor,i.num_item);
      end loop;

      --calcula sada
      for i in cItens_temp(r.num_regra, 'S') loop
          v_qt_saida := v_qt_saida + sf_quant_procs_item(p_num_remessa, p_num_lote,p_sq_setor,i.num_item);
      end loop;

      --calcula pendente 
      for i in cItens_temp(r.num_regra, 'P') loop
          v_qt_pendente := v_qt_pendente + sf_quant_procs_item(p_num_remessa, p_num_lote,p_sq_setor,i.num_item);
      end loop;

      -- valida qtdes
      v_msg:= 'Pend Ant:'||v_qt_pendente_ant || 
              ' Entr:' || v_qt_entrada ||
              ' Sada:' || v_qt_saida ||
              ' Pend:' || v_qt_pendente; 

      if (v_qt_pendente_ant + v_qt_entrada - v_qt_saida) = v_qt_pendente then
          popula_log (r.num_regra,r.desc_regra, p_sq_setor, v_msg,'OK', 'TEMP');
      else  
          popula_log (r.num_regra, r.desc_regra, p_sq_setor, v_msg,'Erro', 'TEMP');           
      end if;

  end loop;
end;

--------------------------- REGRAS EXTRAS -------------------------------
procedure validacao_extra(p_sq_setor number) is
  v_qt1 number;
  v_qt2 number;
  v_msg varchar2(200);

begin
    -- item 250
    select num_quantidade_item
    into v_qt1
    from egt_info_item     
    where num_remessa=p_num_remessa
      and num_lote=p_num_lote
      and num_item  = 250
      and num_orgao_estatistica=p_sq_setor;  

    v_qt2:= sf_quant_procs_item(p_num_remessa, p_num_lote,p_sq_setor,26) +
            sf_quant_procs_item(p_num_remessa, p_num_lote,p_sq_setor,27);

    v_msg:='Quant[250] = ' ||v_qt1 ||'  Quant[26, 27] = ' || v_qt2 ;
        
    if v_qt1 >= v_qt2 then
       popula_log (null,'Item 250 maior ou igual a itens 26 e 27', p_sq_setor, v_msg,'OK','VALEX');
    else
       popula_log (null,'Item 250 maior ou igual a itens 26 e 27', p_sq_setor, v_msg,'Erro','VALEX');
    end if;        

end;

--------------------------- CORPO PRINCIPAL -------------------------------

begin

  delete from vl_log l where l.num_remessa = p_num_remessa and l.num_lote = p_num_lote;
  delete from vl_log_detalhado d where d.num_remessa = p_num_remessa and d.num_lote = p_num_lote;      
  commit;                                                  

  for s in cSetor loop 
      sp_valida_totais(p_num_remessa, p_num_lote, s.sq_setor);
      sp_valida_classes(p_num_remessa, p_num_lote, s.sq_setor);
      validacao_nao_temporal_quant(s.sq_setor);
      validacao_nao_temporal_conj(s.sq_setor);  
      sp_valida_datas(p_num_remessa, p_num_lote, s.sq_setor);
      sp_valida_detalhes_extras(p_num_remessa, p_num_lote, s.sq_setor);
      sp_valida_magistrados(p_num_remessa, p_num_lote, s.sq_setor);
      sp_valida_processos(p_num_remessa, p_num_lote, s.sq_setor);
      validacao_temporal(s.sq_setor);
  end loop;
  
  commit;
                           
exception when others then
   popula_log(null,null,null,'Erro '||sqlerrm,'Erro', null);
       
end;
