-------------------------------------------------------
-- Export file for user EG                           --
-- Created by roterdam.junior on 28/9/2012, 16:24:25 --
-------------------------------------------------------


create or replace procedure sp_validacao_quant_detalhada(p_sq_setor number,
                                                   p_num_regra number,
                                                   p_num_remessa number,
                                                   p_num_lote number,
                                                   p_tp_regra varchar2,
                                                   p_operador varchar2) is

cursor cItens_nao_temp_a(p_num_regra number) is
       select *
       from vl_itens_nao_temp_a
       where num_regra=p_num_regra
       order by num_item;

cursor cItens_nao_temp_b(p_num_regra number) is
       select *
       from vl_itens_nao_temp_b
       where num_regra=p_num_regra
       order by num_item;

cursor cProcessos(p_num_item number) is
       select ip.num_interno_processo
       from egt_info_processo ip
       where ip.num_orgao_estatistica = p_sq_setor
             and ip.num_remessa = p_num_remessa
             and ip.num_lote = p_num_lote
             and ip.num_item = p_num_item;

cursor cProcessosA(p_num_item number) is
       (select ip.num_interno_processo
       from egt_info_processo ip
       where ip.num_orgao_estatistica = p_sq_setor
             and ip.num_remessa = p_num_remessa
             and ip.num_lote = p_num_lote
             and ip.num_item = p_num_item)
        intersect
        (select a.num_interno_processo
         from vl_processos_conj_a a);


cursor cProcessosB(p_num_item number) is
       (select ip.num_interno_processo
       from egt_info_processo ip
       where ip.num_orgao_estatistica = p_sq_setor
             and ip.num_remessa = p_num_remessa
             and ip.num_lote = p_num_lote
             and ip.num_item = p_num_item)
        intersect
        (select b.num_interno_processo
         from vl_processos_conj_b b);

cursor cProcessosAmenosB is 
    select *
    from vl_processos_conj_a a
    where a.num_interno_processo not in (select b.num_interno_processo
                                         from vl_processos_conj_b b);

cursor cProcessosBmenosA is 
    select *
    from vl_processos_conj_b b
    where b.num_interno_processo not in (select a.num_interno_processo
                                         from vl_processos_conj_a a); 


begin
    if p_tp_regra = 'QV' then
        for a in cItens_nao_temp_a(p_num_regra) loop
            for p in cProcessosA(a.num_item) loop
                insert into vl_log_detalhado (sq_setor,
                                              num_regra,
                                              num_interno_processo,
                                              desc_erro,
                                              num_remessa,
                                              num_lote)
                values (p_sq_setor,
                        p_num_regra,
                        p.num_interno_processo,
                        'Item: ' || a.num_item,
                        p_num_remessa,
                        p_num_lote);
            end loop;
        end loop;

        for b in cItens_nao_temp_b(p_num_regra) loop
            for p in cProcessosB(b.num_item) loop
                insert into vl_log_detalhado (sq_setor,
                                              num_regra,
                                              num_interno_processo,
                                              desc_erro,
                                              num_remessa,
                                              num_lote)
                values (p_sq_setor,
                        p_num_regra,
                        p.num_interno_processo,
                        'Item: ' || b.num_item,
                        p_num_remessa,
                        p_num_lote);
            end loop;
        end loop;
    elsif p_tp_regra = 'Q' then
        if p_operador = 'QT_MENOR_IGUAL' then            
            for p in cProcessosAmenosB() loop
                insert into vl_log_detalhado (sq_setor,
                                              num_regra,
                                              num_interno_processo,
                                              desc_erro,
                                              num_remessa,
                                              num_lote)
                values (p_sq_setor,
                        p_num_regra,
                        p.num_interno_processo,
                        'Item: ' || p.num_item,
                        p_num_remessa,
                        p_num_lote);

            end loop;           
        elsif p_operador = 'QT_MAIOR_IGUAL' then
            for p in cProcessosBmenosA() loop
                insert into vl_log_detalhado (sq_setor,
                                              num_regra,
                                              num_interno_processo,
                                              desc_erro,
                                              num_remessa,
                                              num_lote)
                values (p_sq_setor,
                        p_num_regra,
                        p.num_interno_processo,
                        'Item: ' || p.num_item,
                        p_num_remessa,
                        p_num_lote);

            end loop;    
        elsif p_operador = 'QT_IGUAL' then
            for p in cProcessosAmenosB() loop
                insert into vl_log_detalhado (sq_setor,
                                              num_regra,
                                              num_interno_processo,
                                              desc_erro,
                                              num_remessa,
                                              num_lote)
                values (p_sq_setor,
                        p_num_regra,
                        p.num_interno_processo,
                        'Item: ' || p.num_item,
                        p_num_remessa,
                        p_num_lote);
            end loop;           

            for p in cProcessosBmenosA() loop
                insert into vl_log_detalhado (sq_setor,
                                              num_regra,
                                              num_interno_processo,
                                              desc_erro,
                                              num_remessa,
                                              num_lote)
                values (p_sq_setor,
                        p_num_regra,
                        p.num_interno_processo,
                        'Item: ' || p.num_item,
                        p_num_remessa,
                        p_num_lote);
            end loop;    

        end if;

    end if;

    commit;


end;
