-------------------------------------------------------
-- Export file for user EG                           --
-- Created by roterdam.junior on 28/9/2012, 16:25:16 --
-------------------------------------------------------


CREATE OR REPLACE PROCEDURE "SP_VALIDA_DETALHES_EXTRAS" (p_num_remessa number,
                                           p_num_lote number,
                                           p_sq_setor number) is

/*
    Regras:
        1) A contagem de registros dos nmeros das audincias realizadas deve ser igual ao quantitativo informado.
        2) Deve ser informado o rgo de origem para todos os processos do item

        As regras abaixo no foram definidas ainda devido a necessidade de melhor esclarecimento
        1) A contagem de registros de categoria econmica do empregador deve ser igual ao quantitativo informado.
        2) A contagem de registros de municpio de origem da ao deve ser igual ao quantitativo informado
*/

 cursor cQtdeAudiencias is
      select *
      from egt_info_item ii
      where ii.num_remessa = p_num_remessa
            and ii.num_lote = p_num_lote
            and ii.num_item between 174 and 179
            and ii.num_orgao_estatistica = p_sq_setor
            and ii.num_quantidade_item != (select count(*)
                                           from egt_info_audiencia ia
                                           where ia.num_remessa = ii.num_remessa
                                                 and ia.num_lote = ii.num_lote
                                                 and ia.num_item = ii.num_item
                                                 and ia.num_orgao_estatistica = ii.num_orgao_estatistica);

cursor cProcSemOrgaoOrigem is
    select ip.num_item, ip.num_interno_processo
    from egt_info_processo ip
    where ip.num_remessa = p_num_remessa
          and ip.num_lote = p_num_lote
          and ip.num_item in (27,92)
          and ip.num_orgao_estatistica = p_sq_setor
          and ip.num_orgao_estatistica_origem is null;

--------------------------------------------------------------------------------------
procedure popula_log(p_num_regra number,
                     p_desc_regra vl_regras_temp.desc_regra%type,
                     p_sq_setor number,                      
                     p_msg vl_log.msg%type) is

begin
  insert into vl_log values (p_sq_setor,
                             p_num_regra,
                             p_desc_regra,                               
                             p_msg,
                             'Erro',
                             'DETEX',
                             p_num_remessa,
                             p_num_lote);
  commit;                                                               
end;
----------------------------------------------------------------------------------------

begin
  --1)
  FOR C IN cQtdeAudiencias LOOP
      popula_log(401,
                 'Regra de detalhes extras: A contagem de registros dos nmeros das audincias realizadas no  igual ao quantitativo informado.',
                 p_sq_setor,
                 'Remessa: ' || p_num_remessa || 
                 ' Lote: ' || p_num_lote || 
                 ' Item: ' || c.num_item);
  END LOOP;

  --2)
  for p in cProcSemOrgaoOrigem loop
      popula_log(402,
                 'Regra de detalhes extras: Deve ser informado o rgo de origem para todos os processos do item',
                 p_sq_setor,
                 'Remessa: ' || p_num_remessa || 
                 ' Lote: ' || p_num_lote || 
                 ' Item: ' || p.num_item ||
                 ' Processo: ' || p.num_interno_processo);    
  end loop;



end;
