-------------------------------------------------------
-- Export file for user EG                           --
-- Created by roterdam.junior on 28/9/2012, 16:25:38 --
-------------------------------------------------------

CREATE OR REPLACE PROCEDURE "SP_VALIDA_MAGISTRADOS" (p_num_remessa number,
                                       p_num_lote number,
                                       p_sq_setor number) is

/*


    Regras:
        2) Deve ser informado o magistrado para todos os processos do item.

        Regra retirada:
        1) O mesmo magistrado no pode ser titular e substituto no mesmo perodo de atuao.

        As regras abaixo no foram implementadas ainda porque a definio ainda no foi concluda.
        3) O Total de magistrados em exerccio dentro do perodo de referncia deve ser igual
           ao quantitativo informado para o item.
        4) A contagem de registros de magistrado prolator da sentena reformada deve ser igual ao quantitativo informado.


*/

cursor cTitulESubst is
    (select distinct i.num_pessoa
    from egt_info_pessoa i
    where i.num_remessa=p_num_remessa
          and i.num_lote=p_num_lote
          and i.num_orgao_estatistica = p_sq_setor
          and i.num_item = 5)
    intersect
    (select distinct i.num_pessoa
    from egt_info_pessoa i
    where i.num_remessa=p_num_remessa
          and i.num_lote=p_num_lote
          and i.num_orgao_estatistica = p_sq_setor
          and i.num_item = 6);

cursor cProcSemJuiz is
   select ip.num_item, ip.num_interno_processo
   from egt_info_processo ip
   where ip.num_remessa=p_num_remessa
         and ip.num_lote=p_num_lote
         and ip.num_orgao_estatistica = p_sq_setor
         and ip.num_item in (29,30,31,32,65,62,64,39,40,41,42,43,44,46,47,48,49,50,55,35,36,68,75,94,95,96,
                             114,115,118,121,122,125,128,129,132,142,143,354,145,148,149,355,151,154,155,356,
                             157,160,161,357,163,166,167,358,169,174,175,176,177,173,179,269,270)
         and ip.num_juiz is null;


v_nome varchar2(200);

--------------------------------------------------------------------------------------
procedure popula_log(p_num_regra number,
                     p_desc_regra vl_regras_temp.desc_regra%type,
                     p_sq_setor number,                      
                     p_msg vl_log.msg%type) is

begin
  insert into vl_log values (p_sq_setor,
                             p_num_regra,
                             p_desc_regra,                               
                             p_msg,
                             'Erro',
                             'MAGIS',
                             p_num_remessa,
                             p_num_lote);
  commit;                                                               
end;
----------------------------------------------------------------------------------------

begin
    --1)
   --retirada em 25/09/12 pelo comit
   /* for i in cTitulESubst loop
        begin
          select nom_pessoa
          into v_nome
          from egt_pessoa p
          where p.num_pessoa=i.num_pessoa;
        exception when others then
          v_nome:=null;
        end;
        
        popula_log(501,
               'Regra de magistrados: O mesmo magistrado no pode ser titular e substituto no mesmo perodo de atuao',
               p_sq_setor,
               'Remessa: ' || p_num_remessa || 
               ' Lote: ' || p_num_lote ||
               ' Numero do magistrado: ' || i.num_pessoa|| '  '||v_nome);

    end loop;

    commit;*/

    for p in cProcSemJuiz loop
        popula_log(502,
                   'Regra de magistrados: Deve ser informado o magistrado para todos os processos do item.',
                   p_sq_setor,
                   'Remessa: ' || p_num_remessa || 
                   ' Lote: ' || p_num_lote ||
                   'Item: ' || p.num_item ||
                   ' Numero do processo: ' || p.num_interno_processo);
    end loop;


end;
