-------------------------------------------------------
-- Export file for user EG                           --
-- Created by roterdam.junior on 28/9/2012, 16:25:58 --
-------------------------------------------------------


CREATE OR REPLACE PROCEDURE "SP_VALIDA_PROCESSOS" (p_num_remessa number,
                                 p_num_lote number,
                                 p_sq_setor number) is


/*

    Regras:
        A contagem de registros de processo deve ser igual ao quantitativo informado.

*/

cursor cQtdeProcessos is
    select *
    from egt_info_item ii
    where ii.num_remessa = p_num_remessa
          and ii.num_lote = p_num_lote
          and ii.num_orgao_estatistica = p_sq_setor
          and ii.num_item in (select ei.num_item
                              from egt_estrutura_item ei
                              where ei.num_item < 1000
                                    and ei.ind_item_quadro = 'N'
                                    and ei.ind_item_ativo = 'S'
                                    and ei.num_item_superior not in (2,335,172,339,251,255))
          and ii.num_quantidade_item != (select count(*)
                                         from egt_info_processo ip
                                         where ip.num_remessa = ii.num_remessa
                                               and ip.num_lote = ii.num_lote
                                               and ip.num_item = ii.num_item
                                               and ip.num_orgao_estatistica = ii.num_orgao_estatistica);

--------------------------------------------------------------------------------------
procedure popula_log(p_num_regra number,
                     p_desc_regra vl_regras_temp.desc_regra%type,
                     p_sq_setor number,                      
                     p_msg vl_log.msg%type) is

begin
  insert into vl_log values (p_sq_setor,
                             p_num_regra,
                             p_desc_regra,                               
                             p_msg,
                             'Erro',
                             'PROCS',
                             p_num_remessa,
                             p_num_lote);
  commit;                                                               
end;
----------------------------------------------------------------------------------------


begin

  FOR C IN cQtdeProcessos LOOP
    popula_log(601,
               'Regra de processos: A contagem de registros de processos no  igual ao quantitativo informado',
               p_sq_setor,
               'Remessa: ' || c.num_remessa || 
               ' Lote: ' || c.num_lote || 
               ' Item: ' || c.num_item);

  END LOOP;


end;
