-------------------------------------------------------
-- Export file for user EG                           --
-- Created by roterdam.junior on 28/9/2012, 16:27:00 --
-------------------------------------------------------

CREATE OR REPLACE PROCEDURE "SP_VALIDA_CLASSES" (p_num_remessa number,
                                       p_num_lote number,
                                       p_sq_setor number) is

/*


    Regras:
         1) Deve ser informada a classe processual para todos os processos do item.


*/

CURSOR cRegras IS select num_item from vl_item;

cursor cProcSemClasse is
   select ip.num_item, ip.num_interno_processo
   from egt_info_processo ip
   where ip.num_remessa=p_num_remessa
         and ip.num_lote=p_num_lote
         and ip.num_orgao_estatistica = p_sq_setor
         and ip.num_item in (26,27,28,29,30,31,32,33,60,61,65,62,64,39,40,41,42,43,44,46,47,48,49,50,55,35,36,66,68,69,
                     70,315,56,57,293,58,342,73,343,317,78,79,80,319,74,75,76,81,321,322,324,372,325,346,327,
                     329,86,92,91,295,99,102,106,104,300,347,348,349,350,93,94,95,96,98,333,97,110,296,353,
                     103,113,114,115,116,117,118,120,121,122,123,124,125,127,128,129,130,132,141,142,143,144,
                     145,354,147,148,149,150,151,355,153,154,155,156,157,356,159,160,161,162,163,357,165,166,
                     167,168,169,358,174,175,176,177,173,179,182,186,183,187,184,188,185,189,191,192,193,198,
                     199,200,201,204,205,206,207,208,210,211,214,216,217,220,222,223,224,225,226,228,229,
                     230,231,232,234,237,239,241,238,240,242,263,264,265,266,267,268,269,270,271,272,359,
                     371,274,305,275,277,308,309,282,307,310,281,306,311,283,284,278,285,279,286,280,287,
                     362,364,365,367,368,369,370)
         and ip.num_classe is null;


--------------------------------------------------------------------------------------
procedure popula_log(p_num_regra number,
                     p_desc_regra vl_regras_temp.desc_regra%type,
                     p_sq_setor number,
                     p_msg vl_log.msg%type) is

begin
  insert into vl_log values (p_sq_setor,
                             p_num_regra,
                             p_desc_regra,
                             p_msg,
                             'Erro',
                             'CLASS',
                             p_num_remessa,
                             p_num_lote);
  commit;
end;
----------------------------------------------------------------------------------------

begin
    for p in cProcSemClasse loop
        popula_log(701,
                   'Regra de classes: Deve ser informada a classe processual para todos os processos do item.',
                   p_sq_setor,
                   'Remessa: ' || p_num_remessa ||
                   ' Lote: ' || p_num_lote ||
                   'Item: ' || p.num_item ||
                   ' Numero do processo: ' || p.num_interno_processo);
    end loop;

    FOR c IN cRegras LOOP
        sp_vl_valida_classes_por_item(p_num_remessa, p_num_lote, c.num_item, p_sq_setor);        
    END LOOP; 


end;
