-------------------------------------------------------
-- Export file for user EG                           --
-- Created by roterdam.junior on 28/9/2012, 16:28:59 --
-------------------------------------------------------
CREATE OR REPLACE PROCEDURE "SP_VALIDA_TOTAIS" (p_num_remessa number,
                                                 p_num_lote number,
                                                 p_num_orgao_estatistica number) is

/*Verifica se a egt_info_item est corretamente totalizada em relao
a egt_info_processo,egt_info_audiencia e egt_info_pessoa
*/
                                                 
cursor cItens(tp_item number) is
  select * from egt_estrutura_item e
  where e.num_instancia=1
        and e.num_tipo_complemento=tp_item;



  v_qt1 number;
  v_qt2 number;
--------------------------------------------------------------------------      
procedure popula_log(p_num_regra number,
                     p_desc_regra vl_regras_temp.desc_regra%type,
                     p_sq_setor number,                      
                     p_msg vl_log.msg%type, 
                     p_in_validacao vl_log.in_validacao%type,
                     p_tp_regra varchar2) is

begin
  insert into vl_log values (p_sq_setor,
                             p_num_regra,
                             p_desc_regra,                               
                             p_msg,
                             p_in_validacao,
                             p_tp_regra,
                             p_num_remessa,
                             p_num_lote);
  commit;                                                               
end;

BEGIN

  for c in cItens(1) loop --itens de info_processo
    begin
      select num_quantidade_item
      into v_qt1
      from egt_info_item
      where num_remessa=p_num_remessa
        and num_lote=p_num_lote
        and num_item  = c.num_item
        and num_orgao_estatistica=p_num_orgao_estatistica;
    exception when others then
        v_qt1:=0;        
    end;
        
    v_qt2:= sf_quant_procs_item(p_num_remessa, p_num_lote,p_num_orgao_estatistica,c.num_item);

    if v_qt1 <> v_qt2 then
       popula_log (null,'Erro na qtde da info_item no Item '|| c.num_item, p_num_orgao_estatistica, null,'Erro','INFO');
    end if;
  end loop;

  for c in cItens(2) loop --itens de info_pessoa
    begin  
      select num_quantidade_item
      into v_qt1
      from egt_info_item
      where num_remessa=p_num_remessa
        and num_lote=p_num_lote
        and num_item  = c.num_item
        and num_orgao_estatistica=p_num_orgao_estatistica;
    exception when others then
        v_qt1:=0;        
    end;
    
    select count(*)   
    into v_qt2
    from egt_info_pessoa 
    where num_remessa = p_num_remessa
       and num_lote = p_num_lote
       and num_orgao_estatistica = p_num_orgao_estatistica
       and num_item = c.num_item;

    if v_qt1 <> v_qt2 then
       popula_log (null,'Erro na qtde da info_item no Item '|| c.num_item, p_num_orgao_estatistica, null,'Erro','INFO');
    end if;
  end loop;

  for c in cItens(7) loop --itens de info_aud
    begin
      select num_quantidade_item
      into v_qt1
      from egt_info_item
      where num_remessa=p_num_remessa
        and num_lote=p_num_lote
        and num_item  = c.num_item
        and num_orgao_estatistica=p_num_orgao_estatistica;
    exception when others then
        v_qt1:=0;        
    end;
    
    select count(*)   
    into v_qt2
    from egt_info_audiencia 
    where num_remessa = p_num_remessa
       and num_lote = p_num_lote
       and num_orgao_estatistica = p_num_orgao_estatistica
       and num_item = c.num_item;

    if v_qt1 <> v_qt2 then
       popula_log (null,'Erro na qtde da info_item no Item '|| c.num_item, p_num_orgao_estatistica, null,'Erro','INFO');
    end if;
  end loop;


END;
